%define __spec_install_post /usr/lib/rpm/brp-compress || :
%define debug_package %{nil}

%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

# if you make changes, the it is advised to increment this number, and provide 
# a descriptive suffix to identify who owns or what the change represents
# e.g. release_version 2.MSW

Summary:          Cloud File System
Name:             cloudfs
Version:          0.7
Release:          6%{?dist}
License:          AGPLv3+
Group:            System Environment/Base
Vendor:           Red Hat
URL:              http://cloudfs.org
Source0:          http://cloudfs.org/dist/%{version}/%{name}-%{version}.tgz

# Fedora way
BuildRequires:    glusterfs-devel = 3.2.1
BuildRequires:    bison
BuildRequires:    flex 
BuildRequires:    openssl-devel
BuildRequires:    libtool

Requires:         glusterfs = 3.2.1
Requires:         openssl
Requires:         python
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/service
Requires(preun):  /sbin/chkconfig
Requires(postun): /sbin/service

%description
CloudFS is a cloud-capable file system based on GlusterFS (http://gluster.org)
with additional authentication/encryption/multi-tenancy features.

%prep
%setup -q -n %{name}-%{version}

%build

%configure

%{__make} %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot} 
%{__make} install DESTDIR=%{buildroot}
%{__mkdir} -p %{buildroot}%{python_sitelib}
%{__mkdir} %{buildroot}%{python_sitelib}/styles
%{__mkdir} %{buildroot}%{python_sitelib}/views
%{__cp} -pr scripts/* %{buildroot}%{python_sitelib}
%{__mkdir} %{buildroot}%{_bindir}
%{__ln_s} %{python_sitelib}/cfs_add_directory.py %{buildroot}%{_bindir}/cfs_add_directory
%{__ln_s} %{python_sitelib}/cfs_add_node.py %{buildroot}%{_bindir}/cfs_add_node
%{__ln_s} %{python_sitelib}/cfs_add_tenant.py %{buildroot}%{_bindir}/cfs_add_tenant
%{__ln_s} %{python_sitelib}/cfs_add_volume.py %{buildroot}%{_bindir}/cfs_add_volume
%{__ln_s} %{python_sitelib}/cfs_delete_tenant.py %{buildroot}%{_bindir}/cfs_delete_tenant
%{__ln_s} %{python_sitelib}/cfs_enable_tenant.py %{buildroot}%{_bindir}/cfs_enable_tenant
%{__ln_s} %{python_sitelib}/cfs_list_tenants.py %{buildroot}%{_bindir}/cfs_list_tenants
%{__ln_s} %{python_sitelib}/cfs_list_vols.py %{buildroot}%{_bindir}/cfs_list_vols
%{__ln_s} %{python_sitelib}/cfs_mount.py %{buildroot}%{_bindir}/cfs_mount
%{__ln_s} %{python_sitelib}/cfs_rm_volume.py %{buildroot}%{_bindir}/cfs_rm_volume
%{__ln_s} %{python_sitelib}/cfs_start_volume.py %{buildroot}%{_bindir}/cfs_start_volume
%{__ln_s} %{python_sitelib}/cfs_stop_volume.py %{buildroot}%{_bindir}/cfs_stop_volume
%{__ln_s} %{python_sitelib}/cfs_update_cert.py %{buildroot}%{_bindir}/cfs_update_cert
%{__mkdir} %{buildroot}%{_sysconfdir}/
%{__install} -D -p -m0755 cloudfsd %{buildroot}%{_sysconfdir}/init.d/cloudfsd
%{__mkdir} -p %{buildroot}%{_var}/log/cloudfs
%{__mkdir} -p %{buildroot}%{_var}/lib/cloudfs
%{__mkdir} -p %{buildroot}%{_var}/run/cloudfs
%{__mkdir} %{buildroot}%{_var}/run/cloudfs/idle_ports
%{__mkdir} %{buildroot}%{_var}/run/cloudfs/used_ports
%{__mkdir} -p %{buildroot}%{_mandir}/man8
%{__gzip} -c doc/cfs_add_directory.8 > %{buildroot}%{_mandir}/man8/cfs_add_directory.8.gz
%{__gzip} -c doc/cfs_add_node.8 > %{buildroot}%{_mandir}/man8/cfs_add_node.8.gz
%{__gzip} -c doc/cfs_add_tenant.8 > %{buildroot}%{_mandir}/man8/cfs_add_tenant.8.gz
%{__gzip} -c doc/cfs_add_volume.8 > %{buildroot}%{_mandir}/man8/cfs_add_volume.8.gz
%{__gzip} -c doc/cfs_delete_tenant.8 > %{buildroot}%{_mandir}/man8/cfs_delete_tenant.8.gz
%{__gzip} -c doc/cfs_enable_tenant.8 > %{buildroot}%{_mandir}/man8/cfs_enable_tenant.8.gz
%{__gzip} -c doc/cfs_list_tenants.8 > %{buildroot}%{_mandir}/man8/cfs_list_tenants.8.gz
%{__gzip} -c doc/cfs_list_vols.8 > %{buildroot}%{_mandir}/man8/cfs_list_vols.8.gz
%{__gzip} -c doc/cfs_mount.8 > %{buildroot}%{_mandir}/man8/cfs_mount.8.gz
%{__gzip} -c doc/cfs_rm_volume.8 > %{buildroot}%{_mandir}/man8/cfs_rm_volume.8.gz
%{__gzip} -c doc/cfs_start_volume.8 > %{buildroot}%{_mandir}/man8/cfs_start_volume.8.gz
%{__gzip} -c doc/cfs_stop_volume.8 > %{buildroot}%{_mandir}/man8/cfs_stop_volume.8.gz
%{__gzip} -c doc/cfs_update_cert.8 > %{buildroot}%{_mandir}/man8/cfs_update_cert.8.gz
%{__gzip} -c doc/cloudfs.8 > %{buildroot}%{_mandir}/man8/cloudfs.8.gz

# Remove unwanted files from all the shared libraries
find %{buildroot}%{_libdir}/glusterfs -name '*.a' -delete
find %{buildroot}%{_libdir}/glusterfs -name '*.la' -delete

%files
%doc COPYING
%docdir %{_mandir}/man8/
%{_libdir}/glusterfs/3.2.1/xlator/encryption/*.so*
%{_libdir}/glusterfs/3.2.1/xlator/features/*.so*
%{_libdir}/glusterfs/3.2.1/xlator/protocol/*.so*
%{_libdir}/glusterfs/3.2.1/rpc-transport/*.so*
%{python_sitelib}/*
%{_bindir}/*
%{_sysconfdir}/init.d/cloudfsd
%{_var}/log/cloudfs/
%{_var}/lib/cloudfs/
%{_var}/run/cloudfs/
%{_mandir}/man8/*

%post
/sbin/chkconfig --add cloudfsd

%preun
if [ $1 = 0 ]; then
/sbin/service cloudfsd stop &>/dev/null || :
/sbin/chkconfig --del cloudfsd
fi

%changelog
* Fri Jul 29 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-6
- destroy rb tree in fini() to eliminate valgrind warnings
- restore depcomp to package for rpmbuild --rebuild

* Fri Jul 29 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-5
- eliminate valgrind warning in uidmap

* Tue Jul 19 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-4
- add man pages, fix rpm/rpmlint issues for packaging

* Wed Jul 13 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-3
- add ssl socket transport, remove cluster (cloud, login) xlators
- add ssl and cert to gui/cli

* Fri Jul 08 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-2
- fix rpmlint warnings

* Thu Jun 30 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.7-1
- packaging for review with web UI

* Wed Jun 29 2011 Kaleb S. KEITHLEY <kkeithle@redhat.com> - 0.6-1
- used only internally

* Fri Jan 21 2011 Jeff Darcy <jdarcy@redhat.com> - 0.5-1
- Original version based on GlusterFS 3.1.1
